using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.StylusInput;
using Microsoft.StylusInput.PluginData;
using Microsoft.Ink;

namespace RTSCS
{
	public class InkStylusAsync : IStylusAsyncPlugin
	{
		private Control attachedControl;
		private RealTimeStylus myRts;
		private Ink myInk = new Ink();
		private Hashtable myPackets = new Hashtable();

		public Ink Ink
		{
			get
			{
				return this.myInk;
			}
		}

		public InkStylusAsync(Control control, RealTimeStylus rts)
		{
			this.attachedControl = control;
			this.myRts = rts;
		}

		public DataInterestMask DataInterest
		{
			get
			{
				return DataInterestMask.Packets | 
					DataInterestMask.StylusDown | 
					DataInterestMask.StylusUp;
			}
		}

		public void Packets(RealTimeStylus sender, 
			PacketsData data)
		{
			ArrayList list;
			list = (ArrayList)this.myPackets[data.Stylus.Id];
			list.AddRange(data.GetData());
		}

		public void StylusDown(RealTimeStylus sender, 
			StylusDownData data)
		{
			ArrayList newPackets = new ArrayList();
			newPackets.AddRange(data.GetData());
			this.myPackets.Add(data.Stylus.Id, newPackets);
		}

		public void StylusUp(RealTimeStylus sender, 
			StylusUpData data)
		{
			ArrayList list;
			list = (ArrayList)this.myPackets[data.Stylus.Id];
			list.AddRange(data.GetData());

			int[] packets;
			packets = (int[])list.ToArray(typeof(int));

			TabletPropertyDescriptionCollection props; 
			props = this.myRts.GetTabletPropertyDescriptionCollection(data.Stylus.TabletContextId);

			this.myInk.CreateStroke(packets, props);

			this.myPackets.Remove(data.Stylus.Id);
		}

		public void TabletRemoved(RealTimeStylus sender, 
			TabletRemovedData data)
		{}
		public void CustomStylusDataAdded(RealTimeStylus sender, 
			CustomStylusData data)
		{}
		public void RealTimeStylusDisabled(RealTimeStylus sender, 
			RealTimeStylusDisabledData data)
		{}
		public void StylusOutOfRange(RealTimeStylus sender, 
			StylusOutOfRangeData data)
		{}
		public void StylusButtonUp(RealTimeStylus sender, 
			StylusButtonUpData data)
		{}
		public void StylusInRange(RealTimeStylus sender, 
			StylusInRangeData data)
		{}
		public void RealTimeStylusEnabled(RealTimeStylus sender, 
			RealTimeStylusEnabledData data)
		{}
		public void SystemGesture(RealTimeStylus sender, 
			SystemGestureData data)
		{}
		public void TabletAdded(RealTimeStylus sender, 
			TabletAddedData data)
		{}
		public void Error(RealTimeStylus sender, 
			ErrorData data)
		{}
		public void InAirPackets(RealTimeStylus sender, 
			InAirPacketsData data)
		{}
		public void StylusButtonDown(RealTimeStylus sender, 
			StylusButtonDownData data)
		{}
	}
}
