using System;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.StylusInput;
using Microsoft.StylusInput.PluginData;

namespace RTSCS
{
	public class MirrorStylus : IStylusSyncPlugin
	{
		private Control myControl;
		private Control myControl2;
		private Control myControl3;
		private Control myControl4;

		public MirrorStylus(Control control,
			Control ctrl2,
			Control ctrl3,
			Control ctrl4)
		{
			this.myControl = control;
			this.myControl2 = ctrl2;
			this.myControl3 = ctrl3;
			this.myControl4 = ctrl4;
		}

		public DataInterestMask DataInterest
		{
			get
			{
				return DataInterestMask.Packets;
			}
		}

		public void Packets(RealTimeStylus sender, 
			PacketsData data)
		{
			// Get the packet, and convert it to pixels
			Graphics g = this.myControl.CreateGraphics();
			Graphics g2 = this.myControl2.CreateGraphics();
			Graphics g3 = this.myControl3.CreateGraphics();
			Graphics g4 = this.myControl4.CreateGraphics();

			int iX; int iY; int iX2; int iY2;
			int packetCounter;

			for (packetCounter = 0;
				packetCounter <= (data.Count-data.PacketPropertyCount);
				packetCounter += data.PacketPropertyCount)
			{
				iX = (int)(g.DpiX * data[0] / 2540);
				iY = (int)(g.DpiY * data[1] / 2540);

				// We draw "under" the pen
				g.FillEllipse(Brushes.Red, iX - 2, iY - 2, 4, 4);

				// We draw the mirror 
				iX2 = this.myControl2.Width - iX;
				g2.FillEllipse(Brushes.Red, iX2 - 2, iY - 2, 4, 4);

				// We draw the 2nd mirror 
				iY2 = this.myControl3.Height - iY;
				g3.FillEllipse(Brushes.Red, iX - 2, iY2 - 2, 4, 4);

				// We draw the 3rd mirror 
				iY2 = this.myControl4.Height - iY;
				iX2 = this.myControl4.Width - iX;
				g4.FillEllipse(Brushes.Red, iX2 - 2, iY2 - 2, 4, 4);
			}

			g.Dispose();
			g2.Dispose();
			g3.Dispose();
			g4.Dispose();
		}

		public void StylusDown(RealTimeStylus sender, 
			StylusDownData data)
		{}
		public void StylusUp(RealTimeStylus sender, 
			StylusUpData data)
		{}
		public void TabletRemoved(RealTimeStylus sender, 
			TabletRemovedData data)
		{}
		public void CustomStylusDataAdded(RealTimeStylus sender, 
			CustomStylusData data)
		{}
		public void RealTimeStylusDisabled(RealTimeStylus sender, 
			RealTimeStylusDisabledData data)
		{}
		public void StylusOutOfRange(RealTimeStylus sender, 
			StylusOutOfRangeData data)
		{}
		public void StylusButtonUp(RealTimeStylus sender, 
			StylusButtonUpData data)
		{}
		public void StylusInRange(RealTimeStylus sender, 
			StylusInRangeData data)
		{}
		public void RealTimeStylusEnabled(RealTimeStylus sender, 
			RealTimeStylusEnabledData data)
		{}
		public void SystemGesture(RealTimeStylus sender, 
			SystemGestureData data)
		{}
		public void TabletAdded(RealTimeStylus sender, 
			TabletAddedData data)
		{}
		public void Error(RealTimeStylus sender, 
			ErrorData data)
		{}
		public void InAirPackets(RealTimeStylus sender, 
			InAirPacketsData data)
		{}
		public void StylusButtonDown(RealTimeStylus sender, 
			StylusButtonDownData data)
		{}
	}
}
