Imports Microsoft.StylusInput
Imports Microsoft.Ink

Public Class InkStylus
    Implements IStylusSyncPlugin

    Public ReadOnly Property DataInterest() _
    As DataInterestMask _
    Implements IStylusSyncPlugin.DataInterest
        Get
            Return DataInterestMask.Packets _
                Or DataInterestMask.StylusDown _
                Or DataInterestMask.StylusUp
        End Get
    End Property

    Private attachedControl As Control
    Private myRts As RealTimeStylus
    Private myInk As New Ink
    Private myPackets As New Hashtable

    Public ReadOnly Property Ink() As Ink
        Get
            Return Me.myInk
        End Get
    End Property

    Public Sub New(ByVal control As Control, ByVal rts As RealTimeStylus)
        Me.attachedControl = control
        Me.myRts = rts
    End Sub

    Public Sub StylusDown(ByVal sender As RealTimeStylus, _
    ByVal data As PluginData.StylusDownData) _
    Implements IStylusSyncPlugin.StylusDown
        Dim newPackets As New ArrayList
        newPackets.AddRange(data.GetData())
        Me.myPackets.Add(data.Stylus.Id, newPackets)
    End Sub

    Public Sub Packets(ByVal sender As RealTimeStylus, _
    ByVal data As PluginData.PacketsData) _
    Implements IStylusSyncPlugin.Packets
        Dim list As ArrayList
        list = CType(Me.myPackets(data.Stylus.Id), ArrayList)
        list.AddRange(data.GetData())
    End Sub

    Public Sub StylusUp(ByVal sender As RealTimeStylus, _
    ByVal data As PluginData.StylusUpData) _
    Implements IStylusSyncPlugin.StylusUp
        Dim list As ArrayList
        list = CType(Me.myPackets(data.Stylus.Id), ArrayList)
        list.AddRange(data.GetData())

        Dim packets As Integer()
        packets = list.ToArray(GetType(Integer))

        Dim props As TabletPropertyDescriptionCollection
        props = Me.myRts.GetTabletPropertyDescriptionCollection(data.Stylus.TabletContextId)

        Me.myInk.CreateStroke(packets, props)

        Me.myPackets.Remove(data.Stylus.Id)
    End Sub


    Public Sub CustomStylusDataAdded(ByVal sender As RealTimeStylus, ByVal data As PluginData.CustomStylusData) Implements IStylusSyncPlugin.CustomStylusDataAdded
    End Sub
    Public Sub [Error](ByVal sender As RealTimeStylus, ByVal data As PluginData.ErrorData) Implements IStylusSyncPlugin.Error
    End Sub
    Public Sub InAirPackets(ByVal sender As RealTimeStylus, ByVal data As PluginData.InAirPacketsData) Implements IStylusSyncPlugin.InAirPackets
    End Sub
    Public Sub RealTimeStylusDisabled(ByVal sender As RealTimeStylus, ByVal data As PluginData.RealTimeStylusDisabledData) Implements IStylusSyncPlugin.RealTimeStylusDisabled
    End Sub
    Public Sub RealTimeStylusEnabled(ByVal sender As RealTimeStylus, ByVal data As PluginData.RealTimeStylusEnabledData) Implements IStylusSyncPlugin.RealTimeStylusEnabled
    End Sub
    Public Sub StylusButtonDown(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusButtonDownData) Implements IStylusSyncPlugin.StylusButtonDown
    End Sub
    Public Sub StylusButtonUp(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusButtonUpData) Implements IStylusSyncPlugin.StylusButtonUp
    End Sub
    Public Sub StylusInRange(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusInRangeData) Implements IStylusSyncPlugin.StylusInRange
    End Sub
    Public Sub StylusOutOfRange(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusOutOfRangeData) Implements IStylusSyncPlugin.StylusOutOfRange
    End Sub
    Public Sub SystemGesture(ByVal sender As RealTimeStylus, ByVal data As PluginData.SystemGestureData) Implements IStylusSyncPlugin.SystemGesture
    End Sub
    Public Sub TabletAdded(ByVal sender As RealTimeStylus, ByVal data As PluginData.TabletAddedData) Implements IStylusSyncPlugin.TabletAdded
    End Sub
    Public Sub TabletRemoved(ByVal sender As RealTimeStylus, ByVal data As PluginData.TabletRemovedData) Implements IStylusSyncPlugin.TabletRemoved
    End Sub
End Class

