Imports Microsoft.StylusInput
Imports Microsoft.Ink

Public Class InkStylusAsync
    Implements IStylusAsyncPlugin

    Public ReadOnly Property DataInterest() _
    As DataInterestMask _
    Implements IStylusAsyncPlugin.DataInterest
        Get
            Return DataInterestMask.Packets _
                Or DataInterestMask.StylusDown _
                Or DataInterestMask.StylusUp
        End Get
    End Property

    Private attachedControl As Control
    Private myRts As RealTimeStylus
    Private myInk As New Ink
    Private myPackets As New Hashtable

    Public ReadOnly Property Ink() As Ink
        Get
            Return Me.myInk
        End Get
    End Property

    Public Sub New(ByVal control As Control, ByVal rts As RealTimeStylus)
        Me.attachedControl = control
        Me.myRts = rts
    End Sub

    Public Sub StylusDown(ByVal sender As RealTimeStylus, _
    ByVal data As PluginData.StylusDownData) _
    Implements IStylusAsyncPlugin.StylusDown
        Dim newPackets As New ArrayList
        newPackets.AddRange(data.GetData())
        Me.myPackets.Add(data.Stylus.Id, newPackets)
    End Sub

    Public Sub Packets(ByVal sender As RealTimeStylus, _
    ByVal data As PluginData.PacketsData) _
    Implements IStylusAsyncPlugin.Packets
        Dim list As ArrayList
        list = CType(Me.myPackets(data.Stylus.Id), ArrayList)
        list.AddRange(data.GetData())
    End Sub

    Public Sub StylusUp(ByVal sender As RealTimeStylus, _
    ByVal data As PluginData.StylusUpData) _
    Implements IStylusAsyncPlugin.StylusUp
        Dim list As ArrayList
        list = CType(Me.myPackets(data.Stylus.Id), ArrayList)
        list.AddRange(data.GetData())

        Dim packets As Integer()
        packets = list.ToArray(GetType(Integer))

        Dim props As TabletPropertyDescriptionCollection
        props = Me.myRts.GetTabletPropertyDescriptionCollection(data.Stylus.TabletContextId)

        Me.myInk.CreateStroke(packets, props)

        Me.myPackets.Remove(data.Stylus.Id)
    End Sub


    Public Sub CustomStylusDataAdded(ByVal sender As RealTimeStylus, ByVal data As PluginData.CustomStylusData) Implements IStylusAsyncPlugin.CustomStylusDataAdded
    End Sub
    Public Sub [Error](ByVal sender As RealTimeStylus, ByVal data As PluginData.ErrorData) Implements IStylusAsyncPlugin.Error
    End Sub
    Public Sub InAirPackets(ByVal sender As RealTimeStylus, ByVal data As PluginData.InAirPacketsData) Implements IStylusAsyncPlugin.InAirPackets
    End Sub
    Public Sub RealTimeStylusDisabled(ByVal sender As RealTimeStylus, ByVal data As PluginData.RealTimeStylusDisabledData) Implements IStylusAsyncPlugin.RealTimeStylusDisabled
    End Sub
    Public Sub RealTimeStylusEnabled(ByVal sender As RealTimeStylus, ByVal data As PluginData.RealTimeStylusEnabledData) Implements IStylusAsyncPlugin.RealTimeStylusEnabled
    End Sub
    Public Sub StylusButtonDown(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusButtonDownData) Implements IStylusAsyncPlugin.StylusButtonDown
    End Sub
    Public Sub StylusButtonUp(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusButtonUpData) Implements IStylusAsyncPlugin.StylusButtonUp
    End Sub
    Public Sub StylusInRange(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusInRangeData) Implements IStylusAsyncPlugin.StylusInRange
    End Sub
    Public Sub StylusOutOfRange(ByVal sender As RealTimeStylus, ByVal data As PluginData.StylusOutOfRangeData) Implements IStylusAsyncPlugin.StylusOutOfRange
    End Sub
    Public Sub SystemGesture(ByVal sender As RealTimeStylus, ByVal data As PluginData.SystemGestureData) Implements IStylusAsyncPlugin.SystemGesture
    End Sub
    Public Sub TabletAdded(ByVal sender As RealTimeStylus, ByVal data As PluginData.TabletAddedData) Implements IStylusAsyncPlugin.TabletAdded
    End Sub
    Public Sub TabletRemoved(ByVal sender As RealTimeStylus, ByVal data As PluginData.TabletRemovedData) Implements IStylusAsyncPlugin.TabletRemoved
    End Sub
End Class
