Imports Microsoft.StylusInput

Public Class InkStylusAsyncForm
    Inherits System.Windows.Forms.Form

    Private rts As RealTimeStylus
    Private myDynamicRenderer As dynamicRenderer
    Private myRenderer As New Microsoft.Ink.Renderer
    Private stylus As InkStylusAsync

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'We create the stylus
        Me.rts = New RealTimeStylus(Me)

        ' We create the plug-in
        Me.stylus = New InkStylusAsync(Me, Me.rts)
        Me.rts.AsyncPluginCollection.Add(Me.stylus)

        ' We create a default dynamic renderer
        Me.myDynamicRenderer = New DynamicRenderer(Me)
        Me.rts.SyncPluginCollection.Add(Me.myDynamicRenderer)

        ' We enable everything
        Me.myDynamicRenderer.Enabled = True
        Me.rts.Enabled = True
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
        Me.Text = "SimpleStylusForm"
    End Sub

#End Region

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' Make sure the new ink is refreshed properly
        Me.myDynamicRenderer.Refresh()

        ' Render ink in the ink object
        Me.myRenderer.Draw(e.Graphics, Me.stylus.Ink.Strokes)
    End Sub
End Class
