Imports Microsoft.StylusInput

Public Class MirrorStylus
    Implements IStylusSyncPlugin

    Private myControl As System.Windows.Forms.Control
    Private myControl2 As System.Windows.Forms.Control
    Private myControl3 As System.Windows.Forms.Control
    Private myControl4 As System.Windows.Forms.Control

    Public Sub New(ByVal control1 As Control, ByVal ctrl2 As Control, ByVal ctrl3 As Control, ByVal ctrl4 As Control)
        Me.myControl = control1
        Me.myControl2 = ctrl2
        Me.myControl3 = ctrl3
        Me.myControl4 = ctrl4
    End Sub


    Public ReadOnly Property DataInterest() As Microsoft.StylusInput.DataInterestMask Implements Microsoft.StylusInput.IStylusSyncPlugin.DataInterest
        Get
            Return DataInterestMask.Packets
        End Get
    End Property


    Public Sub Packets(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.PacketsData) Implements Microsoft.StylusInput.IStylusSyncPlugin.Packets
        ' Get the packet, and convert it to pixels
        Dim g As Graphics = Me.myControl.CreateGraphics()
        Dim g2 As Graphics = Me.myControl2.CreateGraphics()
        Dim g3 As Graphics = Me.myControl3.CreateGraphics()
        Dim g4 As Graphics = Me.myControl4.CreateGraphics()

        Dim iX As Integer
        Dim iY As Integer
        Dim iX2 As Integer
        Dim iY2 As Integer

        Dim packetCounter As Integer
        For packetCounter = 0 To data.Count - data.PacketPropertyCount _
        Step data.PacketPropertyCount
            iX = g.DpiX * data(0) / 2540
            iY = g.DpiY * data(1) / 2540

            ' We draw "under" the pen
            g.FillEllipse(Brushes.Red, iX - 2, iY - 2, 4, 4)

            ' We draw the mirror 
            iX2 = Me.myControl2.Width - iX
            g2.FillEllipse(Brushes.Red, iX2 - 2, iY - 2, 4, 4)

            ' We draw the 2nd mirror 
            iY2 = Me.myControl3.Height - iY
            g3.FillEllipse(Brushes.Red, iX - 2, iY2 - 2, 4, 4)

            ' We draw the 3rd mirror 
            g4.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
            iY2 = Me.myControl4.Height - iY
            iX2 = Me.myControl4.Width - iX
            g4.FillEllipse(Brushes.Red, iX2 - 2, iY2 - 2, 4, 4)
        Next
        g.Dispose()
        g2.Dispose()
        g3.Dispose()
        g4.Dispose()
    End Sub

    Public Sub StylusDown(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.StylusDownData) Implements Microsoft.StylusInput.IStylusSyncPlugin.StylusDown
    End Sub
    Public Sub CustomStylusDataAdded(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.CustomStylusData) Implements Microsoft.StylusInput.IStylusSyncPlugin.CustomStylusDataAdded
    End Sub
    Public Sub [Error](ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.ErrorData) Implements Microsoft.StylusInput.IStylusSyncPlugin.Error
    End Sub
    Public Sub InAirPackets(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.InAirPacketsData) Implements Microsoft.StylusInput.IStylusSyncPlugin.InAirPackets
    End Sub
    Public Sub RealTimeStylusDisabled(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.RealTimeStylusDisabledData) Implements Microsoft.StylusInput.IStylusSyncPlugin.RealTimeStylusDisabled
    End Sub
    Public Sub RealTimeStylusEnabled(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.RealTimeStylusEnabledData) Implements Microsoft.StylusInput.IStylusSyncPlugin.RealTimeStylusEnabled
    End Sub
    Public Sub StylusButtonDown(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.StylusButtonDownData) Implements Microsoft.StylusInput.IStylusSyncPlugin.StylusButtonDown
    End Sub
    Public Sub StylusButtonUp(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.StylusButtonUpData) Implements Microsoft.StylusInput.IStylusSyncPlugin.StylusButtonUp
    End Sub
    Public Sub StylusInRange(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.StylusInRangeData) Implements Microsoft.StylusInput.IStylusSyncPlugin.StylusInRange
    End Sub
    Public Sub StylusOutOfRange(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.StylusOutOfRangeData) Implements Microsoft.StylusInput.IStylusSyncPlugin.StylusOutOfRange
    End Sub
    Public Sub StylusUp(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.StylusUpData) Implements Microsoft.StylusInput.IStylusSyncPlugin.StylusUp
    End Sub
    Public Sub SystemGesture(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.SystemGestureData) Implements Microsoft.StylusInput.IStylusSyncPlugin.SystemGesture
    End Sub
    Public Sub TabletAdded(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.TabletAddedData) Implements Microsoft.StylusInput.IStylusSyncPlugin.TabletAdded
    End Sub
    Public Sub TabletRemoved(ByVal sender As Microsoft.StylusInput.RealTimeStylus, ByVal data As Microsoft.StylusInput.PluginData.TabletRemovedData) Implements Microsoft.StylusInput.IStylusSyncPlugin.TabletRemoved
    End Sub
End Class
